This patch-collection provides for reasonably warning-free compile of
xcoral. const-poison sprinkled throughout.

The result even seems to work... Use at your own risk.

TODO:	figure out the best way to use actual paths to various
executables (like cpp), which are currently hard-coded (to, for example,
"/lib/cpp").

	-mi

--- BR_Global.h	1997-09-16 04:18:38.000000000 -0400
+++ BR_Global.h	2014-12-27 23:35:12.000000000 -0500
@@ -55,14 +55,36 @@ typedef BR_UChar         BR_Boolean;
    /*-----------------------------------------------------------------------*/
 
-#define BR_WARNING(msg, arg)      \
-  fprintf(stderr, msg, arg);
+#define BR_WARNING(msg, ...)      \
+  fprintf(stderr, msg, __VA_ARGS__);
 
 
-#define BR_FATAL_ERROR(msg, arg)  \
+#define BR_FATAL_ERROR(msg, ...)  \
 {                                 \
-  fprintf(stderr, msg, arg);      \
+  fprintf(stderr, msg, __VA_ARGS__);      \
   exit(1);                        \
 }
 
+int browser_dump(const char *file_name);
+int browser_restore(const char *file_name);
+int browser_yyparse(const char *file_name);
+void browser_set_pp(const char *modename, const char *path);
+void browser_set_pp_options(const char *modename, const char *options);
+void browser_add(const char *s, int rec);
+const char *browser_class_file(const char *class_name, int *pline);
+int browser_select_class(const char *prefix);
+const char *browser_class_flags(const char *class_name);
+int browser_select_method(const char *prefix);
+int browser_select_attribute(const char *prefix);
+int browser_select_proc(const char *prefix);
+int browser_select_global(const char *prefix);
+int browser_class_entry(const char *prefix);
+int browser_function_entry(const char *prefix);
+int browser_global_entry(const char *prefix);
+int browser_file_entry(const char *prefix);
+const char *browser_class(int n);
+const char *browser_function(int n);
+const char *browser_global(int n);
+const char *browser_file(int n);
+const char *MyStrerror(int err);
 
-#endif  /* BR_GLOBAL_H */
+#endif  /* BR_GLOBAL_H */
\ No newline at end of file
--- BR_Interface.h	2002-12-17 08:51:12.000000000 -0500
+++ BR_Interface.h	2014-12-26 23:56:07.000000000 -0500
@@ -75,8 +75,8 @@
    /*-----------------------------------------------------------------------*/
 
-typedef FCT(void, (*BR_InfoHandler), (BR_Str*  prefix,
-				      BR_Str*  syntax_unit,
-				      BR_ULong infos,
-				      BR_ULong line_num) );
+typedef FCT(void, (*BR_InfoHandler), (const BR_Str*  prefix,
+				      const BR_Str*  syntax_unit,
+				      BR_ULong       infos,
+				      BR_ULong       line_num) );
 
 
@@ -99,8 +99,7 @@ typedef FCT(void, (*BR_InfoHandler), (BR
 
 extern
-FCT(BR_Boolean, BR_parse_file, (BR_Str*        file_name,
+FCT(BR_Boolean, BR_parse_file, (const BR_Str*  file_name,
 				BR_InfoHandler info_handler,
 				BR_Str**       filter_cmd) );
 
-
-#endif  /* BR_INTERFACE_H */
+#endif  /* BR_INTERFACE_H */
\ No newline at end of file
--- BR_Lexer.h	1997-05-15 04:36:08.000000000 -0400
+++ BR_Lexer.h	2014-12-27 02:34:08.000000000 -0500
@@ -34,5 +34,5 @@ struct BR_TokenRec
   BR_Int              _code;
   struct BR_TokenRec *_prefix;
-  BR_Str             *_val;
+  const BR_Str       *_val;
   BR_ULong            _val_len;
   BR_ULong            _bits;
@@ -54,5 +54,5 @@ extern YYSTYPE      BR_yylval;
 
 #define yylex       BR_yylex
-extern BR_Int       BR_yylex();
+extern BR_Int       BR_yylex(void);
 
 
@@ -60,9 +60,9 @@ extern BR_Int       BR_yylex();
 
 extern
-FCT (void, BR_lex_init, (FILE* main_file, BR_Str* main_name) );
+FCT (void, BR_lex_init, (FILE* main_file, const BR_Str* main_name) );
 
 
 extern
-FCT (void, BR_lex_empty_frame, () );
+FCT (void, BR_lex_empty_frame, (void));
 
 extern
@@ -70,5 +70,5 @@ FCT (BR_TokenPt, BR_lex_stack_frame, (BR
 
 extern
-FCT (BR_TokenPt, BR_lex_unstack_frame, () );
+FCT (BR_TokenPt, BR_lex_unstack_frame, (void));
 
 
@@ -77,5 +77,5 @@ FCT (BR_TokenPt, BR_lex_alloc_token, (BR
 
 extern
-FCT (BR_Int, BR_lex_get_line_num, ());
+FCT (BR_Int, BR_lex_get_line_num, (void));
 
 
@@ -83,11 +83,11 @@ FCT (BR_Int, BR_lex_get_line_num, ());
 
 extern
-FCT (void, BR_lex_ignore_proc_tail, () );
+FCT (void, BR_lex_ignore_proc_tail, (void));
 
 extern
-FCT (void, BR_lex_jump_bracket, () );
+FCT (void, BR_lex_jump_bracket, (void));
 
 extern
-FCT (void, BR_lex_jump_colon, () );
+FCT (void, BR_lex_jump_colon, (void));
 
 
@@ -95,9 +95,8 @@ FCT (void, BR_lex_jump_colon, () );
 
 extern
-FCT (void, BR_lex_save_state, () );
+FCT (void, BR_lex_save_state, (void));
 
 extern
-FCT (void, BR_lex_synchronize, () );
+FCT (void, BR_lex_synchronize, (void));
 
-
-#endif  /* BR_LEXER_H */
+#endif  /* BR_LEXER_H */
\ No newline at end of file
--- BR_Lexer.l	2002-12-18 02:17:45.000000000 -0500
+++ BR_Lexer.l	2014-12-27 02:36:54.000000000 -0500
@@ -90,5 +90,5 @@ static BR_Int          str_error_cnt  = 
 
 static BR_Str       val_buf[MAX_TOKEN_COUNT * MAX_VAL_LEN];
-static BR_Str*      val_next = val_buf;
+static BR_Str*      val_next = val_buf, *val_current;
 static BR_Str*      val_max  = &(val_buf[VAL_BUF_SIZE - 2]);
 
@@ -193,5 +193,5 @@ static BR_Int top_state = 0;
 
 #define GET_FREE_STR(val, len)      \
-  val       = val_next;                                       \
+  val = val_current = val_next;                               \
   val_next += len;                                            \
   if (val_next > val_max)                                     \
@@ -239,5 +239,5 @@ static BR_Int top_state = 0;
   GET_FREE_TOKEN(yylval);                      \
   GET_FREE_STR(yylval->_val, yyleng);          \
-  strncpy(yylval->_val, yytext, yyleng);       \
+  strncpy(val_current, yytext, yyleng);       \
   yylval->_code     = key;                     \
   yylval->_val_len  = yyleng;                  \
@@ -248,6 +248,5 @@ static BR_Int top_state = 0;
   yylval->_bits     = BR_INFO_EMPTY;           \
   return(key);                                 \
-}  
-
+}
 
    /*-----------------------------------------------------------------------*/
@@ -880,5 +879,5 @@ void
 BR_lex_init(main_file, main_name)
     FILE* main_file;
-    char* main_name;
+    const char* main_name;
 {
   if (yyin == 0)
@@ -912,5 +911,5 @@ BR_lex_empty_frame()
 {
   token_next         = token_frame + 1;
-  val_next           = token_frame->_val;
+  val_next           = (void *)token_frame->_val;
   token_frame->_bits = token_frame->_val_len;
   token_const        = BR_Null;
@@ -953,5 +952,5 @@ BR_TokenPt
 BR_lex_unstack_frame()
 {
-  val_next    = token_frame->_val;
+  val_next    = (void *)token_frame->_val;
   token_next  = token_frame->_last;
   token_frame = token_frame->_next;
--- BR_Parser.y	2002-12-18 02:21:52.000000000 -0500
+++ BR_Parser.y	2014-12-27 23:36:54.000000000 -0500
@@ -29,7 +29,9 @@
 #include <fcntl.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <unistd.h>
 #include <setjmp.h>
 #include <signal.h>
+#include <errno.h>
 
 #if HAVE_STRING_H
@@ -85,5 +87,5 @@
    /*-----------------------------------------------------------------------*/
 
-FCT (int, yyerror, (char*) );
+FCT (int, yyerror, (const char*) );
 
 
@@ -92,8 +94,5 @@ FCT (int, yyerror, (char*) );
 #define YYPRINT(f, t, v)        BR_yyprint(f, t, v)
 static
-FCT (int, BR_yyprint, (FILE*, int, YYSTYPE) );
-
-static
-FCT (void, BR_dump_tree, (BR_Str*, BR_TokenPt) );
+FCT (int, BR_yyprint, (FILE*, int token, YYSTYPE));
 
 #endif
@@ -102,5 +101,5 @@ FCT (void, BR_dump_tree, (BR_Str*, BR_To
    /*-----------------------------------------------------------------------*/
 
-static char* basic_value[] =
+static const char* basic_value[] =
 {
   /*   0  (signed)? int         */      "int ",
@@ -142,9 +141,16 @@ static int basic_length[] =
 };
 
+#if 1
 #define CONVERT_BASIC(x)        \
    (x->_val     = basic_value[x->_bits],   \
     x->_val_len = basic_length[x->_bits],  \
     x)
-
+#else
+#define CONVERT_BASIC(x)        \
+   (GET_FREE_STR(x->_val, basic_length[x->_bits]), \
+    strncpy(x->_val, basic_value[x->_bits], basic_length[x->_bits]), \
+    x->_val_len = basic_length[x->_bits], \
+    x)
+#endif
 
    /*-----------------------------------------------------------------------*/
@@ -1280,17 +1286,15 @@ Access
 #if YYDEBUG != 0
 
-static char val[1024];
-
 static int
-BR_yyprint(f, t, v)
+BR_yyprint(f, token, v)
      FILE*   f;
-     int     t;
+     int     token;
      YYSTYPE v;
 {
   if ((v != BR_Null) && (v->_val != BR_Null))
   {
-    strncpy(val, yylval->_val, (BR_Int) yylval->_val_len + 1);      
-    *(val + yylval->_val_len + 1) = '\0';
-    fprintf(f, "   [(l=%05ld) \"%s\"]", yylval->_line_num, val);
+    fprintf(f, "   [(l=%05ld) %s\t\"%.*s\"]", yylval->_line_num,
+            yytname[yytoknum[token]],
+            (int)yylval->_val_len + 1, yylval->_val);
   }
   return(0);
@@ -1304,11 +1308,11 @@ BR_yyprint(f, t, v)
 int
 yyerror(msg)
-     char* msg;
+     const char* msg;
 {
   if (BR_info_handler != BR_Null)
     BR_info_handler("", "", BR_INFO_ERROR, BR_lex_get_line_num());
   else
-    BR_WARNING(">>>>>  Hum, Hum !!! Strange construction at line : %d\n",
-	       BR_lex_get_line_num());
+    fprintf(stderr, ">>>>>  Hum, Hum !!! Strange construction at line : %d: %s\n",
+	       BR_lex_get_line_num(), msg);
 
   return(0);
@@ -1376,36 +1380,4 @@ BR_replace_template_args(token)
    /*-----------------------------------------------------------------------*/
 
-#if YYDEBUG != 0
-
-static BR_Str dump_buff[1024];
-
-static void
-BR_dump_tree(msg, tree)
-     BR_Str*    msg;
-     BR_TokenPt tree;
-{
-  BR_TokenPt curr_tok;
-
-  fprintf(stderr, "%s\n", msg);
-  curr_tok = tree;
-  while (curr_tok != BR_Null)
-  {
-    strncpy(dump_buff, curr_tok->_val, curr_tok->_val_len);
-    dump_buff[curr_tok->_val_len] = '\0';
-    fprintf(stderr, "   (p=0x%08lx, n=0x%08lx, l=0x%08lx, b=0x%08lx) %s\n",
-	            (BR_ULong) curr_tok,
-	            (BR_ULong) curr_tok->_next,
-	            (BR_ULong) curr_tok->_last,
-	            (BR_ULong) curr_tok->_bits,
-	            dump_buff);
-    curr_tok = curr_tok->_next;
-  }
-}
-
-#endif
-
-  
-   /*-----------------------------------------------------------------------*/
-
 static void
 BR_format_SU(SU_tree, default_infos)
@@ -1416,5 +1388,5 @@ BR_format_SU(SU_tree, default_infos)
   BR_TokenPt  curr_tok;
   BR_Str*     curr_buf;
-  BR_Str*     curr_val;
+  const BR_Str* curr_val;
   BR_ULong    infos;
   BR_TokenPt  prefix;
@@ -1647,5 +1619,5 @@ BR_signal_handler()
 BR_Boolean
 BR_parse_file(file_name, info_handler, filter_cmd)
-     BR_Str          *file_name;
+     const BR_Str    *file_name;
      BR_InfoHandler   info_handler;
      BR_Str         **filter_cmd;
@@ -1691,5 +1663,5 @@ BR_parse_file(file_name, info_handler, f
 	  close(p_array[0]);
 	  execv(filter_cmd[0], filter_cmd);
-	  BR_FATAL_ERROR(">>>>>  Execv failure (\"%s\")\n", filter_cmd[0]);
+	  BR_FATAL_ERROR(">>>>>  Execv failure (\"%s\"): %s\n", filter_cmd[0], MyStrerror(errno));
 	}
 	else
@@ -1697,5 +1669,5 @@ BR_parse_file(file_name, info_handler, f
 	  close(p_array[1]);
 	  close(p_array[0]);
-	  BR_WARNING(">>>>>  Filter fork failure (\"%s\")\n", filter_cmd[0]);
+	  BR_WARNING(">>>>>  Filter fork failure (\"%s\"): %s\n", filter_cmd[0], MyStrerror(errno));
 	  parse_ok = BR_FALSE;
 	}
--- BR_main.c	2003-01-06 03:42:43.000000000 -0500
+++ BR_main.c	2014-12-27 23:35:57.000000000 -0500
@@ -1,3 +1,4 @@
 #include <stdio.h>
+#include <unistd.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -34,4 +35,5 @@
 #include "browser_eve.h"
 #include "page.h"
+#include "warn_box.h"
 
 #include "BR_Global.h"
@@ -41,5 +43,5 @@ extern Browser br;
 
 #if !HAVE_STRDUP
-extern FCT (char*, strdup, (char*) );
+extern FCT (char*, strdup, (const char*) );
 #endif
 
@@ -57,22 +59,22 @@ static ScopeType compute_scope(infos)
 
 static int yaerror;
-static char * filename;
+static const char * filename;
 
-void
+static void
 browser_handler(str_prefix, str_syntax_unit, infos, line_num)
-    BR_Str*  str_prefix;
-    BR_Str*  str_syntax_unit;
+    const BR_Str*  str_prefix;
+    const BR_Str*  str_syntax_unit;
     BR_ULong infos;
     BR_ULong line_num;
 {
-  static BR_Str* erroned_prefix = 0;
+  static BR_Str* erroned_prefix;
   
   if (infos & BR_INFO_ERROR) {
     if (OpVerbose()) {
       if (! yaerror)
-	fprintf(stderr, "Browser : parse error in %s line(s) %d",
-		filename, line_num);
+	fprintf(stderr, "Browser : parse error in %s line(s) %lu",
+		filename, (unsigned long)line_num);
       else
-	fprintf(stderr, " %d", line_num);
+	fprintf(stderr, " %lu", (unsigned long)line_num);
     }
     yaerror = 1;
@@ -83,6 +85,6 @@ browser_handler(str_prefix, str_syntax_u
       return;
     if (erroned_prefix) {
-      BR_Str * s1, *s2;
-      
+      const BR_Str * s1, *s2;
+ 
       for (s1 = str_prefix, s2 = erroned_prefix; (*s1)&&(*s2); s1 += 1, s2 += 1)
 	if (*s1 != *s2)
@@ -95,5 +97,5 @@ browser_handler(str_prefix, str_syntax_u
 	/* out of redefined class */
 	free(erroned_prefix);
-	erroned_prefix = 0;
+	erroned_prefix = NULL;
       }
       else if (! *s2) {
@@ -103,10 +105,10 @@ browser_handler(str_prefix, str_syntax_u
 	/* out of redefined class */
 	free(erroned_prefix);
-	erroned_prefix = 0;
+	erroned_prefix = NULL;
       }
     }
     if (((infos & BR_INFO_CLASS) && (infos & BR_INFO_DEF)) ||
 	(infos & (BR_INFO_STRUCT | BR_INFO_UNION | BR_INFO_TYPEDEF))) {
-      char * n = (char *)
+      char * n =
 	malloc(strlen(str_prefix) + strlen(str_syntax_unit) + 3);
       
@@ -129,5 +131,5 @@ browser_handler(str_prefix, str_syntax_u
 	  
 	  sprintf(n, "%s::%s", str_prefix, str_syntax_unit);
-	  add_proc_impl(n, C_PROC, line_num,
+	  add_proc_impl(n, line_num,
 			((infos & BR_INFO_STATIC) ? STATIC_PROC : 0) +
 			((infos & BR_INFO_TEMPLATE) ? TEMPLATE_PROC : 0),
@@ -154,6 +156,5 @@ browser_handler(str_prefix, str_syntax_u
       if (infos & BR_INFO_NAMESPACE_ELEMENT) {
 	if (infos & BR_INFO_DEF) {
-	  /*int decl = (infos >> 10) & 8;	/* static */
-	  char * n = (char *)
+	  char * n =
 	    malloc(strlen(str_prefix) + strlen(str_syntax_unit) + 3);
 	  
@@ -179,5 +180,5 @@ browser_handler(str_prefix, str_syntax_u
   else if (infos & BR_INFO_PROC) {
     if (infos & BR_INFO_DEF)
-      add_proc_impl(str_syntax_unit, C_PROC, line_num,
+      add_proc_impl(str_syntax_unit, line_num,
 		    ((infos & BR_INFO_STATIC) ? STATIC_PROC : 0) +
 		    ((infos & BR_INFO_INLINE) ? INLINE_PROC : 0) +
@@ -210,5 +211,5 @@ browser_handler(str_prefix, str_syntax_u
 
 int browser_yyparse(fn)
-    char * fn;
+    const char * fn;
 {
   yaerror = 0;
@@ -222,6 +223,7 @@ int browser_yyparse(fn)
 
     filter_cmd[0] = br.mode->pp_path;
-    filter_cmd[1] = fn;
+    filter_cmd[1] = strdup(fn);
     BR_parse_file(fn, browser_handler, filter_cmd);
+    free(filter_cmd[1]);
   }
   else {
@@ -230,5 +232,5 @@ int browser_yyparse(fn)
     char * p;
     unsigned nentry = 3;
-    
+ 
     options = strdup(br.mode->pp_options);
     p = strtok(options, " \t");
@@ -238,5 +240,5 @@ int browser_yyparse(fn)
     }
     
-    filter_cmd = (char **) malloc(nentry * sizeof(char *));
+    filter_cmd = malloc(nentry * sizeof(char *));
     filter_cmd[0] = br.mode->pp_path;
     
@@ -250,12 +252,12 @@ int browser_yyparse(fn)
       nentry += 1;
     }
-    filter_cmd[nentry] = fn;
+    filter_cmd[nentry] = strdup(fn);
     filter_cmd[nentry + 1] = BR_Null;
   
     BR_parse_file(fn, browser_handler, filter_cmd);
     
-    while (--nentry) {
+    do {
       free(filter_cmd[nentry]);
-    }
+    } while (nentry--);
     free(filter_cmd);
     free(options);
@@ -268,6 +270,4 @@ int browser_yyparse(fn)
 }
 
-int yywrap() { return 1; }
-
 /*-------------------------------------------------------------------------
    fonctions Smac
@@ -275,6 +275,6 @@ int yywrap() { return 1; }
 
 void browser_set_pp(modename, path)
-    char * modename;
-    char * path;
+    const char * modename;
+    const char * path;
 {
   Mode * mode = GetMode(modename);
@@ -290,6 +290,6 @@ void browser_set_pp(modename, path)
 
 void browser_set_pp_options(modename, options)
-    char * modename;
-    char * options;
+    const char * modename;
+    const char * options;
 {
   Mode * mode = GetMode(modename);
@@ -317,5 +317,5 @@ void browser_set_pp_options(modename, op
 
 void browser_add(s, rec)
-    char * s;
+    const char * s;
     int rec;
 {
@@ -384,6 +384,6 @@ void browser_add(s, rec)
 }
 
-char * browser_class_file(class_name, pline)
-    char * class_name;
+const char * browser_class_file(class_name, pline)
+    const char * class_name;
     int * pline;
 {
@@ -398,7 +398,6 @@ char * browser_class_file(class_name, pl
 }
 
-
-char * browser_class_flags(class_name)
-    char * class_name;
+const char * browser_class_flags(class_name)
+    const char * class_name;
 {
   ClassRec* class = find_class(class_name);
@@ -411,6 +410,6 @@ char * browser_class_flags(class_name)
 }
 
-static char * browser_select_x(prefix, t, w_x, x_plength)
-    char * prefix;
+static const char * browser_select_x(prefix, t, w_x, x_plength)
+    const char * prefix;
     char **t;
     unsigned w_x;
@@ -452,7 +451,7 @@ static char * browser_select_x(prefix, t
 
 int browser_select_class(prefix)
-    char * prefix;
+    const char * prefix;
 {
-  char * s = 
+  const char * s = 
     browser_select_x(prefix, br.class_save, W_CLASS, CLASS_PLENGTH);
   
@@ -461,7 +460,7 @@ int browser_select_class(prefix)
 
 int browser_select_method(prefix)
-    char * prefix;
+    const char * prefix;
 {
-  char * s = 
+  const char * s = 
     browser_select_x(prefix, br.methods_save, W_METHOD, METHOD_PLENGTH);
   
@@ -470,7 +469,7 @@ int browser_select_method(prefix)
 
 int browser_select_attribute(prefix)
-    char * prefix;
+    const char * prefix;
 {
-  char * s = 
+  const char * s = 
     browser_select_x(prefix, br.attributes_save,
 		     W_ATTRIBUTES, ATTRIBUTE_PLENGTH);
@@ -480,7 +479,7 @@ int browser_select_attribute(prefix)
 
 int browser_select_proc(prefix)
-    char * prefix;
+    const char * prefix;
 {
-  char * s = 
+  const char * s = 
     browser_select_x(prefix, br.procs_save, W_PROC, PROC_PLENGTH);
   
@@ -489,7 +488,7 @@ int browser_select_proc(prefix)
 
 int browser_select_global(prefix)
-    char * prefix;
+    const char * prefix;
 {
-  char * s = 
+  const char * s = 
     browser_select_x(prefix, br.globals_save, W_GLOBALS, GLOBAL_PLENGTH);
   
@@ -498,10 +497,10 @@ int browser_select_global(prefix)
 
 static int browser_x_entry(prefix, save)
-    char * prefix;
-    char ** save;
+    const char * prefix;
+    char * const * save;
 {
   if (save) {
     unsigned plen = strlen(prefix);
-    char ** p;
+    char * const * p;
  
     for (p = save; *p; p += 1) {
@@ -519,5 +518,5 @@ static int browser_x_entry(prefix, save)
 
 int browser_class_entry(prefix)
-    char * prefix;
+    const char * prefix;
 {
   return browser_x_entry(prefix, br.class_save);
@@ -525,5 +524,5 @@ int browser_class_entry(prefix)
 
 int browser_function_entry(prefix)
-    char * prefix;
+    const char * prefix;
 {
   return browser_x_entry(prefix, br.procs_save);
@@ -531,5 +530,5 @@ int browser_function_entry(prefix)
 
 int browser_global_entry(prefix)
-    char * prefix;
+    const char * prefix;
 {
   return browser_x_entry(prefix, br.globals_save);
@@ -537,12 +536,12 @@ int browser_global_entry(prefix)
 
 int browser_file_entry(prefix)
-    char * prefix;
+    const char * prefix;
 {
   return browser_x_entry(prefix, br.files_save);
 }
 
-static char * browser_x(rang, save)
+static const char * browser_x(rang, save)
     int rang;
-    char ** save;
+    char * const * save;
 {
   if (save)
@@ -551,8 +550,8 @@ static char * browser_x(rang, save)
 	return *save;
   
-  return 0;
+  return NULL;
 }
 
-char * browser_class(n)
+const char * browser_class(n)
     int n;
 {
@@ -560,5 +559,5 @@ char * browser_class(n)
 }
 
-char * browser_function(n)
+const char * browser_function(n)
     int n;
 {
@@ -566,5 +565,5 @@ char * browser_function(n)
 }
 
-char * browser_global(n)
+const char * browser_global(n)
     int n;
 {
@@ -572,5 +571,5 @@ char * browser_global(n)
 }
 
-char * browser_file(n)
+const char * browser_file(n)
     int n;
 {
@@ -594,6 +593,4 @@ char * browser_file(n)
 #define TYPE_INFO_DATA		7
 
-extern FCT(void, DisplayWMessage ,(char *, char *, int));
-
 /* to memorize data defined in a file */
 
@@ -626,5 +623,5 @@ typedef struct FileData {
 
 /* link each file and its functions */
-void proc_memo_file()
+static void proc_memo_file()
 {
   ProcRec ** pdict;
@@ -651,5 +648,5 @@ void proc_memo_file()
 
 /* link each file and its globals */
-void global_memo_file()
+static void global_memo_file()
 {
   GlobalRec ** pdict;
@@ -676,5 +673,5 @@ void global_memo_file()
 
 /* link each file and its classes and methods */
-void class_memo_file()
+static void class_memo_file()
 {
   ClassRec ** pdict;
@@ -733,5 +730,5 @@ static void dump_nbr(nbr, fp)
 /* saves a string */
 static void dump_str(str, fp)
-    char * str;
+    const char * str;
     FILE * fp;
 {
@@ -877,5 +874,5 @@ static void save_globals(lglobal, fp)
 
 int browser_dump(fn)
-    char * fn;
+    const char * fn;
 {
   FILE * fp = fopen(fn, "w");
@@ -965,5 +962,5 @@ static char * restore_str(fp)
 {
   int len = restore_nbr(fp);
-  char * str = (char *) malloc(len);
+  char * str = malloc(len);
   
   if (str)
@@ -1046,5 +1043,5 @@ static int browser_restore_file(fp, vers
 	    if (! name)
 	      return 0;
-	    add_proc_impl(name, C_PROC, impl_line, decl, restore_nbr(fp));
+	    add_proc_impl(name, impl_line, decl, restore_nbr(fp));
 	    free(name);
 	  }
@@ -1160,5 +1157,5 @@ static int browser_restore_file(fp, vers
 
 int browser_restore(fn)
-    char * fn;
+    const char * fn;
 {
   FILE * fp = fopen(fn, "r");
@@ -1195,2 +1192,31 @@ int browser_restore(fn)
 }
 
+/*---------------------------------------------------------------------
+*/
+const char*
+MyStrerror ( err )
+    int err;
+{
+#if HAVE_STRERROR
+   return strerror ( err );
+#elif HAVE_SYSERR || HAVE_STDIO_SYSERR
+#  if !HAVE_STDIO_SYSERR
+   extern char *sys_errlist[];
+   extern int sys_nerr;
+#  endif
+   static char buffer[32];
+   if (!err)
+     return "";
+ 
+   if ((err > 0) && (err < sys_nerr))
+     return (char*) sys_errlist[err];
+ 
+   sprintf (buffer, "Unknown error : %d", err);
+   return buffer;
+#else
+#if HAVE_PERROR
+   perror("System error in xcoral execution");
+#endif
+   return("<<< Error message unavailble >>>");
+#endif
+}
\ No newline at end of file
--- Smac/Array_.c	2006-10-16 16:24:55.000000000 -0400
+++ Smac/Array_.c	2014-12-27 22:08:32.000000000 -0500
@@ -58,6 +58,6 @@
 /* Les fonctions d'acces aux elements en fonction de leur type */
 
-Object array_char_access(p, index)
-     char * p;
+static Object array_char_access(p, index)
+     const char * p;
      int index;
 {
@@ -76,6 +76,6 @@ Object array_char_access(p, index)
 }
 
-Object array_int_access(p, index)
-     int * p;
+static Object array_int_access(p, index)
+     const int * p;
      int index;
 {
@@ -98,6 +98,6 @@ Object array_int_access(p, index)
 }
 
-Object array_pointer_access(p, index)
-     Object * p;
+static Object array_pointer_access(p, index)
+     const Object * p;
      int index;
 {
@@ -121,6 +121,6 @@ Object array_pointer_access(p, index)
 }
 
-Object sub_array_access(p, index, subsize)
-     char * p;
+static Object sub_array_access(p, index, subsize)
+     const char * p;
      int index;
      int subsize;
@@ -189,5 +189,5 @@ static Object ArrayAccess__Eval(this)
 /* Les fonctions d'affectation des elements en fonction de leur type */
 
-Object array_char_affect(p, index, value)
+static Object array_char_affect(p, index, value)
      char * p;
      int index;
@@ -197,5 +197,5 @@ Object array_char_affect(p, index, value
 }
 
-Object array_int_affect(p, index, value)
+static Object array_int_affect(p, index, value)
      int * p;
      int index;
@@ -205,5 +205,5 @@ Object array_int_affect(p, index, value)
 }
 
-Object array_pointer_affect(p, index, value)
+static Object array_pointer_affect(p, index, value)
      Object * p;
      int index;
@@ -218,5 +218,5 @@ Object array_pointer_affect(p, index, va
    car le test d'adresse est realise lors de l'acces */
 
-Object check_array_char_affect(p, index, value)
+static Object check_array_char_affect(p, index, value)
      char * p;
      int index;
@@ -229,5 +229,5 @@ Object check_array_char_affect(p, index,
 }
 
-Object check_array_int_affect(p, index, value)
+static Object check_array_int_affect(p, index, value)
      int * p;
      int index;
@@ -245,5 +245,5 @@ Object check_array_int_affect(p, index, 
 }
 
-Object check_array_pointer_affect(p, index, value)
+static Object check_array_pointer_affect(p, index, value)
      Object * p;
      int index;
@@ -275,5 +275,5 @@ ArrayAssignment * ArrayAssignment__Array
      FCT( Object,(* convert),(Object));
 {
-  ArrayAssignment * this = (ArrayAssignment *) Malloc(sizeof(ArrayAssignment));
+  ArrayAssignment * this = Malloc(sizeof(ArrayAssignment));
 
   Instruction_Constructor
--- Smac/Array_.h	2006-10-16 16:22:39.000000000 -0400
+++ Smac/Array_.h	2014-12-27 22:08:49.000000000 -0500
@@ -125,5 +125,5 @@ extern FCT( ArrayPostIncrDecr *,ArrayPos
 /**/
 
-extern void Init_Array();
+extern void Init_Array(void);
 
 #endif
--- Smac/Block_.h	2006-10-16 16:22:13.000000000 -0400
+++ Smac/Block_.h	2014-12-27 17:05:51.000000000 -0500
@@ -55,5 +55,5 @@ typedef struct Block Block;
 extern FCT( Block *,  Block__Block,(int nexpr, Instruction ** instrs) );
      
-extern void Init_Block();
+extern void Init_Block(void);
      
 #endif
--- Smac/Builtin_.c	2006-10-16 16:25:29.000000000 -0400
+++ Smac/Builtin_.c	2014-12-27 22:04:13.000000000 -0500
@@ -65,4 +65,5 @@
 #include "error.h"
 #include "smac.h"
+#include "mylex.h"
 
 /*******************
@@ -451,11 +452,11 @@ HashTable * builtin_fct_nbre_arg_min;
 #ifdef RUNTIMECHECK
 
-char * CHECK(pt)
-     char * pt;
+static char * CHECK(pt)
+     const char * pt;
 {
   if ((pt < Address_Min) || (pt > Address_Char_Max))
     Error("string access out of your memory area", 0);
 
-  return pt;
+  return (char *)pt;
 }
 
@@ -466,5 +467,5 @@ char * CHECK(pt)
 #endif
   
-static int builtin_printf(a)
+static Object builtin_printf(a)
      Instruction ** a;
 {
@@ -751,7 +752,7 @@ static Object builtin_strlen(a)
 
 int check_strlen(s)
-     char *s;
+     const char *s;
 {
-  char * begin = s;
+  const char * begin = s;
 
   while (*CHECK(s++));
@@ -1092,12 +1093,8 @@ static Object builtin_load_file(a)
      Instruction ** a;
 {
-  extern FILE * yyin;
-  extern void load_file(int);
-  extern void smac_read_new_file();
-  
   FILE * previous_yyin = yyin;
   int previous_yyinflag = yyinflag;
   int previous_numlig = numlig;
-  char * previous_yyinfilename = yyinfilename;
+  const char * previous_yyinfilename = yyinfilename;
 #ifdef XCORAL_LIB_DIR
   char *smaclib = 0;
@@ -1111,6 +1108,4 @@ static Object builtin_load_file(a)
 
   if (*yyinfilename == '~') {
-    FCT(char *, ExpandTildeName,(char *));
-
     yyinfilename = ExpandTildeName(yyinfilename);
   }
@@ -1229,6 +1224,6 @@ static int profile_count;
 static int profiling;
 
-void profile_tic(ignore)
-     int ignore;
+static void profile_tic(ignore)
+     int ignore __attribute__((unused));
 {
   if (Last_Function_Called) {
@@ -1240,5 +1235,5 @@ void profile_tic(ignore)
 
 static Object builtin_start_profile(ignore)
-     Instruction ** ignore;
+     Instruction ** ignore __attribute__((unused));
 {
   static struct itimerval prof;
@@ -1271,5 +1266,5 @@ static Object builtin_start_profile(igno
 
 static Object builtin_stop_profile(ignore)
-     Instruction ** ignore;
+     Instruction ** ignore __attribute__((unused));
 {
   signal(SIGVTALRM, SIG_IGN);
@@ -1280,6 +1275,6 @@ static Object builtin_stop_profile(ignor
 
 static void err_pas_fonc(a, f)
-     Instruction ** a;
-     char * f;
+     Instruction * const * a;
+     const char * f;
 {
   sprintf(err_msg, "%s argument type is ", f);
@@ -1327,5 +1322,5 @@ static Object builtin_function(a)
      Instruction ** a;
 {
-  char * name = (char *) Eval(*a);
+  const char * name = (char *) Eval(*a);
   Identifier * id;
   
@@ -1344,6 +1339,6 @@ static Object builtin_function_name(a)
 
   if (IsaFunction((Instruction *) func)) {
-    char * func_name = Function__Name(func);
-    char * result = (char *) RTCMalloc(strlen(func_name) + 1);
+    const char * func_name = Function__Name(func);
+    char * result = RTCMalloc(strlen(func_name) + 1);
     
     if (result) {
@@ -1414,5 +1409,5 @@ static int fi_end = 1;
 
 static Object builtin_init_function_list(ignore)
-     Instruction ** ignore;
+     Instruction ** ignore __attribute__((unused));
 {
   fi_item = 0;
@@ -1424,5 +1419,5 @@ static Object builtin_init_function_list
 
 static Object builtin_function_list(ignore)
-     Instruction ** ignore;
+     Instruction ** ignore __attribute__((unused));
 {
   if (! fi_end)
--- Smac/Builtin_.h	2006-10-16 16:23:42.000000000 -0400
+++ Smac/Builtin_.h	2014-12-27 22:01:43.000000000 -0500
@@ -64,14 +64,14 @@ extern HashTable * builtin_fct_nbre_arg_
 extern HashTable * binary_modifoper_hashtable;
 
-extern FCT(int, check_strlen,(char *)	);
-extern FCT(Object, new_builtin,(char *, Type *, int, Type **,
+extern FCT(int, check_strlen, (const char *)	);
+extern FCT(Object, new_builtin, (char *, Type *, int, Type **,
 				FCT (Object, (*fct),(Instruction **))) );
 
-extern void Init_Builtin();
+extern void Init_Builtin(void);
 
 #ifdef XCORAL
-extern FCT(void, stop_profile,()	);
-extern FCT(void, rerun_profile,()	);
+extern FCT(void, stop_profile, (void)	);
+extern FCT(void, rerun_profile, (void)	);
 #endif
 
-#endif
+#endif
\ No newline at end of file
--- Smac/Cast_.h	2006-10-16 16:23:13.000000000 -0400
+++ Smac/Cast_.h	2014-12-27 22:05:44.000000000 -0500
@@ -56,5 +56,5 @@ typedef struct Cast Cast;
 extern FCT( Cast *,Cast__Cast,(Instruction *, Type *, ConvFct)	);
 
-extern FCT( void, Init_Cast,()			       		);
+extern FCT( void, Init_Cast, (void)		       		);
      
 #endif
--- Smac/Comma_.h	2006-10-16 16:22:35.000000000 -0400
+++ Smac/Comma_.h	2014-12-27 17:07:05.000000000 -0500
@@ -57,5 +57,5 @@ extern FCT(CommaExpression *, CommaExpre
 	   (Instruction ** discarded, Instruction * last, int ndisc)	);
 
-extern void Init_CommaExpression();
+extern void Init_CommaExpression(void);
 
 #endif
--- Smac/Const_.c	2006-10-16 16:24:17.000000000 -0400
+++ Smac/Const_.c	2014-12-27 16:59:39.000000000 -0500
@@ -137,5 +137,5 @@ static Object String__Eval(this)
 
 static void String__Delete(this)
-     String * this;
+     String * this __attribute__((unused));
 {
   /* does nothing : the string may be memorized else where */
--- Smac/Const_.h	2006-10-16 16:22:09.000000000 -0400
+++ Smac/Const_.h	2014-12-27 16:58:54.000000000 -0500
@@ -68,5 +68,5 @@ typedef struct Int Int;
 extern FCT( Int *, Int__Int,(int) );
      
-void Init_Int();
+void Init_Int(void);
 
 
@@ -82,5 +82,5 @@ typedef struct Char Char;
 extern FCT( Char *, Char__Char,(int) );
      
-void Init_Char();
+void Init_Char(void);
 
      
@@ -96,6 +96,5 @@ typedef struct String String;
 extern FCT( String *, String__String,(char *) );
      
-void Init_String();
-
-#endif
+void Init_String(void);
 
+#endif
\ No newline at end of file
--- Smac/Control_.h	2006-10-16 16:23:37.000000000 -0400
+++ Smac/Control_.h	2014-12-27 22:05:09.000000000 -0500
@@ -55,5 +55,5 @@ typedef struct Control Control;
 extern FCT( Control *, Control__Control,(JMP_TYPE)	);
 
-extern void Init_Control();
+extern void Init_Control(void);
 
 #endif
--- Smac/Declaration_.h	2006-10-16 16:23:05.000000000 -0400
+++ Smac/Declaration_.h	2014-12-27 22:04:32.000000000 -0500
@@ -56,5 +56,5 @@ extern FCT( Declaration *, Declaration__
 	   (Instruction *, FCT2( Object,(*),(Object)), int)	);
 
-extern void Init_Declaration();
+extern void Init_Declaration(void);
 
 #endif
